# CHANGELOG

## 2021.0.1 (Minimum Viable Product)

This is the initial release of Modelur4Rhino MVP version.

- Modelur4Rhino has panel type user interface in Rhino.
- Panel has 4 tab page; Whole Plot, Land Use, Building and Survey.
    - Whole Plot
        - Plot Parameters section to change default land use and calculate Floor Area Ratio and Site Coverage.
        - Default Building Parameters section to change default elementary values of buildings at the same time.
    - Land Use
        - Land Use Requirements section to change basic secondary parameters like NFA and GFA factors, Assessed Investment and Income. 
    - Building
        - Selected Building Parameters section responsible for creation and manipulation of building. It has elementary parameters of buildings to control.
    - Survey
        - Urban Control Survey On Screen section navigates the design of Heads-Up Display.
- Simple building creations and manipulations allowed with both user interface and Rhino reactions, yet it has some undo/redo limitations for Rhino reactions.
- Ordinary Rhino tools can be used to change building shape in ways that don't render the building invalid.
- Modelur plugin prevents the manipulations of the building geometry from Rhino, that would render a Modelur building invalid. For example manipulations that would make floor surfaces not horizontal or that would break solids.
- Data export of urban control values to .csv and .txt file with encoding UTF-8.
- Heads-up display is provided with different design options.
- Primary and secondary urban parameters can be shown in both user interface and heads-up display.
- 10 different language ready to use.
    - English
    - French
    - Chinese
    - Slovenian
    - Spanish
    - Dutch
    - German
    - Italian
    - Polish
    - Portuguese
- Modelur4Rhino initializes with English language at the first time. User can change language in UI then language preferences keep in the AppData\Modelur\local.rhino.json file. Modelur4Rhino will use this user preferences anymore.

## 2021.3.23

- Feature: Live Excel synchronization feature is added.
- Feature: Mixed-use buildings feature is added.
- Feature: Dynamic land uses feature is added.
- Enhancement: UI was getting slow when building count increased, this performance issue improved.
- Enhancement: Rhino layers can be used for different alternatives.

## 2021.5.18

- Feature: Transparent background for Heads-Up Display is added.
- Feature: City Blocks are implemented.
- Feature: Interactive 3D zoning is implemented. Buildings can adopt their own city block defaults when relocated.
- Feature: Proximity checks can be done on city block buildings automatically.
- BugFix: When user was trying to create building from non-planar curve, Rhino was crashing.
- BugFix: Only top storeys could have terrace area, now each storey can have terrace and loggia.
- BugFix: One storey buildings was crashing Rhino when user tries to increase number of storeys.
- BugFix: Built-up Area aggregation mistake is fixed. 
- Enhancement: Building can be created and moved to different elevations.
- Enhancement: Non-planar curves project onto minimum elevation automatically while building or city block creating.

## 2021.6.1

- Feature: Font size for Heads-Up Display is added.
- Feature: Proximity checks can be calculated also for whole plot.
- Feature: Proximity checks can be enabled/disabled from Survey tab page for city blocks and whole plot buildings.
- Enhancement: Named cells are implemented for live excel, by this way users can use other cells for their own purposes.
- Enhancement: Selection delay fixed.

## 2021.7.20

- BugFix: When document have buildings that created in different document with user-defined land use that land use not created in current document, it caused crash on file.
- BugFix: Land use of the building was not changing in appropriate way when building moved from city block to city block.
- Enhancement: Proximity checks have been speeded up with geometrical improvements.

## 2022.7.19

- Enhancement: Licensing system has been changed with license key entering and providing registration trial if user do not have license key.

## 2022.7.29

- Enhancement: Excel Live Sync feature can be used edited excel versions, which means that users can define custom work sheets on their Excel file.

## 2022.8.1

- BugFix: Updating Excel table twice issue is solved.

## 2022.08.11

- Feature: Building Name is available.
- Enhancement: About dialog is available under the Help menu. It shows license information and version of the Modelur that is running.
- Enhancement: License plan restrictions are implemented. User can create Modelur objects as much as license plan restricted.

## 2023.01.08

- Feature: City Block data is available on Live Excel.
- BugFix: API call fixed for license plan restrictions. 